/* Aravis - Digital camera library
 *
 * Copyright © 2009-2010 Emmanuel Pacaud
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Author: Emmanuel Pacaud <emmanuel@gnome.org>
 */

#ifndef ARV_H
#define ARV_H

#define ARV_H_INSIDE

#include <arvtypes.h>

#include <arvfeatures.h>
#include <arvversion.h>
#include <arvdebug.h>
#include <arvmisc.h>
#include <arvstr.h>
#include <arvzip.h>
#include <arvsystem.h>
#include <arvevaluator.h>
#include <arvdomnode.h>
#include <arvdomnodelist.h>
#include <arvdomdocument.h>
#include <arvdomelement.h>
#include <arvdomcharacterdata.h>
#include <arvdomtext.h>
#include <arvdomimplementation.h>
#include <arvdomparser.h>
#include <arvcamera.h>
#include <arvgc.h>
#include <arvgcnode.h>
#include <arvgcpropertynode.h>
#include <arvgcfeaturenode.h>
#include <arvgccategory.h>
#include <arvgcboolean.h>
#include <arvgcenumeration.h>
#include <arvgcenumentry.h>
#include <arvgcintegernode.h>
#include <arvgcfloatnode.h>
#include <arvgcregisternode.h>
#include <arvgccommand.h>
#include <arvgcswissknife.h>
#include <arvgcconverter.h>
#include <arvgcport.h>
#include <arvgcregister.h>
#include <arvgcinteger.h>
#include <arvgcfloat.h>
#include <arvgcstring.h>
#include <arvinterface.h>
#include <arvdevice.h>
#include <arvstream.h>
#include <arvbuffer.h>
#include <arvchunkparser.h>
#include <arvgvcp.h>
#include <arvgvsp.h>
#include <arvgvinterface.h>
#include <arvgvdevice.h>
#include <arvgvstream.h>
#if ARAVIS_HAS_USB
#include <arvuvcp.h>
#include <arvuvsp.h>
#include <arvuvinterface.h>
#include <arvuvdevice.h>
#include <arvuvstream.h>
#endif
#include <arvfakeinterface.h>
#include <arvfakedevice.h>
#include <arvfakestream.h>
#include <arvfakecamera.h>
#include <arvgvfakecamera.h>
#include <arvrealtime.h>
#include <arvxmlschema.h>

#undef ARV_H_INSIDE

#endif
